SystemOrganization addCategory: #'GT-InspectorExtensions-Pillar'!

!PRDocumentItem methodsFor: '*GT-InspectorExtensions-Pillar' stamp: 'TudorGirba 4/1/2014 07:43'!
gtInspectorTextIn: composite
	<gtInspectorPresentationOrder: 40>
	composite text 
		title: 'Text';
		display: [ self text ]! !

GLMHighlighterTextDecorator subclass: #GTPillarHighlighterTextDecorator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-InspectorExtensions-Pillar'!

!GTPillarHighlighterTextDecorator class methodsFor: 'as yet unclassified' stamp: 'TudorGirba 8/1/2014 11:55'!
key
	^ self name! !

!GTPillarHighlighterTextDecorator methodsFor: 'as yet unclassified' stamp: 'TudorGirba 8/1/2014 18:22'!
parse: aString onError: anError
	
	^ String cr asText join: (
		aString asString lines collect: [:each | 
			(each beginsWith: '!!') 
				ifTrue: [ each asText makeAllColor: Color blue darker ]
				ifFalse: [ (self treatFileLinks: each) asText ]
	]).! !

!GTPillarHighlighterTextDecorator methodsFor: 'as yet unclassified' stamp: 'TudorGirba 8/1/2014 12:07'!
parser
	^ self! !

!GTPillarHighlighterTextDecorator methodsFor: 'as yet unclassified' stamp: 'TudorGirba 8/12/2014 07:07'!
treatFileLinks: aText
	
	| name filePreamble fileName fileLabel fileLink parser |
	name := (#word asParser plus flatten , $> asParser) flatten.
	filePreamble := 'file://' asParser.
	fileName := (#word asParser / $. asParser) plus flatten
		==> [ :t | 
			t asText addAttribute: 
				("GTPillarFileTextLink new fileName: t"
				TextColor color: Color red) ].
	fileLabel := name optional ==> [:t | t ifNil: ['' asText]].
	fileLink := $+ asParser , fileLabel , filePreamble, fileName , $+ asParser
	 ==> [: t | '' asText join: t ].
	parser := ((fileLink / fileLink negate plus flatten ==> [:t | '' asText join: t]) star  
		==> [:t | ('' asText join: t) ] ).
	^ parser parse: aText ! !

TextLink subclass: #GTPillarFileTextLink
	instanceVariableNames: 'fileReference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-InspectorExtensions-Pillar'!

!GTPillarFileTextLink methodsFor: 'as yet unclassified' stamp: 'TudorGirba 8/1/2014 17:58'!
actOnClick: anEvent for: anObject in: paragraph editor: editor
	^ fileReference inspect! !

!GTPillarFileTextLink methodsFor: 'as yet unclassified' stamp: 'TudorGirba 8/1/2014 18:09'!
fileName: aString
	fileReference := aString! !

!FileReference methodsFor: '*GT-InspectorExtensions-Pillar' stamp: 'TudorGirba 4/8/2014 06:54'!
gtInspectorPillarConfigurationIn: composite
	<gtInspectorPresentationOrder: 40>
	(self basename = 'pillar.conf')
		ifFalse: [ ^ self ].
	((PRSTONConfigurationInterpreter baseDirectory: self parent)
		buildFromFile: self)
			gtInspectorInputFilesIn: composite! !

!FileReference methodsFor: '*GT-InspectorExtensions-Pillar' stamp: 'TudorGirba 8/1/2014 23:51'!
gtInspectorPillarIn: composite
	<gtInspectorPresentationOrder: 40>
	(self extension = 'pillar')
		ifFalse: [ ^ self ].
	
	composite custom: (GLMRubricHighlightedTextPresentation new
		title: 'Pillar';
		editingMode: [GLMHighlighterTextRubEditingMode forStyler: #GTPillarHighlighterTextDecorator];
		display: [ self readStreamDo: #contents ];
		act: [:rub | 
			self ensureDelete; writeStreamDo: [ :s | s nextPutAll: rub text asString ]
			] icon: GLMUIThemeExtraIcons glamorousSave on: $s entitled: 'Save')! !

!PRDocumentGroup methodsFor: '*GT-InspectorExtensions-Pillar' stamp: 'TudorGirba 4/1/2014 07:42'!
gtInspectorTreeIn: composite
	<gtInspectorPresentationOrder: 40>
	composite tree 
		title: 'Tree';
		display: [ { self } ];
		children: [ :each | 
			each hasChildren 
				ifTrue: [each children]
				ifFalse: [ { } ] ];
		when: #hasChildren! !

!PRExportConfiguration methodsFor: '*GT-InspectorExtensions-Pillar' stamp: 'TudorGirba 4/8/2014 06:52'!
gtInspectorInputFilesIn: composite
	<gtInspectorPresentationOrder: 40>
	^ composite list 
		title: 'Files';
		display: [self inputFiles];
		format: #basename! !
